#!/usr/bin/perl -w

#
# Simple script to check status of master and slave
#

use strict;
use warnings;

use DBI;

my $dbhost = 'localhost';
my $dbname = 'mysql';
my $dbuser = 'root';
my $dbpass = '';

my $dbh = DBI->connect("dbi:mysql:$dbname:$dbhost", $dbuser, $dbpass)
										or die "Cannot connect: $DBI::errstr!";
my $slave_stat = $dbh->selectrow_hashref("SHOW SLAVE STATUS");

my $err_msg = "MASTER STATUS:\n\t";
my $master_stat = $dbh->selectrow_hashref("SHOW MASTER STATUS");
if(!$master_stat->{File}) {
	$err_msg .= "Master is down: binary log is not found!";
} elsif(!$master_stat->{Position}) {
	$err_msg .= "Master is down: position is NULL!";
} else {
	$err_msg .= "Master is running ...";
}

$err_msg .= "SLAVE STATUS:\n\t";

if($slave_stat->{Slave_Running} && $slave_stat->{Slave_Running} eq 'No') {
	$err_msg .= "Slave is not running!";
} elsif($slave_stat->{Slave_Running} && $slave_stat->{Slave_Running} eq 'Yes' 
		&& !$slave_stat->{Log_File}) {
	$err_msg .= "Slave does not have binary log file!";
} else {
	$err_msg .= "Slave is running ...";
}

$err_msg .= "\n\tLast Error No: [$slave_stat->{Last_errno}]" if $slave_stat->{Last_errno}; 
$err_msg .= "\n\tLast Error: [$slave_stat->{Last_error}]" if $slave_stat->{Last_error};


$dbh->disconnect;

print "$err_msg\n";
